## sopt 2.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(Sopt CXX)

# Location of extra cmake includes for the project
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_files)
# Downloads and installs GreatCMakeCookOff
# It contains a number of cmake recipes
include(LookUp-GreatCMakeCookOff)

# Version and git hash id
include(VersionAndGitRef)
set_version(2.0.0)
get_gitref()

option(tests          "Enable testing"                         on)
option(python         "Enable python"                          on)
option(benchmarks     "Enable benchmarking"                    on)
option(examples       "Enable Examples"                        on)
option(logging        "Enable logging"                         on)
option(regressions    "Enable regressions"                     on)
option(openmp         "Enable OpenMP"                          on)
option(archer         "Compiling on ARCHER"                    off)

if(regressions)
  enable_language(C)
endif()
if(tests)
  enable_testing()
endif()

# Add c++11 stuff
include(AddCPP11Flags)
include(CheckCXX11Features)
if(tests AND python)
  include(AddPyTest)
endif()
cxx11_feature_check(REQUIRED unique_ptr nullptr override constructor_delegate)
include(compilations)

# search/install dependencies
include(dependencies)
# sets rpath policy explicitly
if(CMAKE_VERSION VERSION_LESS 3.0)
    set_property(GLOBAL PROPERTY MACOSX_RPATH ON)
else()
    cmake_policy(SET CMP0042 NEW)
endif()

if(tests OR examples)
  enable_testing()
endif()

if(tests)
  include(AddCatchTest)
endif()
if(examples)
  include(AddExample)
endif()

if(benchmarks)
  include(AddBenchmark)
endif()
if(regressions)
  include(AddRegression)
endif()
if(python)
  include(python_dependencies)
  include(PythonModule)
endif()

if(python)
  add_subdirectory(python)
endif()

add_subdirectory(cpp)

# Exports all Sopt so other packages can access it
include(export_sopt)

=== cpp/CMakeLists.txt ===
# Setup logging
set(SOPT_LOGGER_NAME "sopt" CACHE STRING "NAME of the logger")
set(SOPT_COLOR_LOGGING true CACHE BOOL "Whether to add color to the log")
if(logging)
  set(SOPT_DO_LOGGING 1)
  set(SOPT_TEST_LOG_LEVEL critical CACHE STRING "Level when logging tests")
  set_property(CACHE SOPT_TEST_LOG_LEVEL PROPERTY STRINGS
    off critical error warn info debug trace)
else()
  unset(SOPT_DO_LOGGING)
  set(SOPT_TEST_LOG_LEVEL off)
endif()

set(version ${Sopt_VERSION})
string(REGEX REPLACE "\\." ";" version "${Sopt_VERSION}")
list(GET version 0 Sopt_VERSION_MAJOR)
list(GET version 1 Sopt_VERSION_MINOR)
list(GET version 2 Sopt_VERSION_PATCH)

configure_file(sopt/config.in.h "${PROJECT_BINARY_DIR}/include/sopt/config.h")

add_subdirectory(sopt)
if(regressions OR examples)
  # Tiff wrappers and whatnot
  add_subdirectory(tools_for_tests)
endif()
if(tests)
  add_subdirectory(tests)
endif()
if(examples)
  add_subdirectory(examples)
endif()
if(benchmarks)
  add_subdirectory(benchmarks)
endif()
if(regressions)
  add_subdirectory(regressions)
endif()

=== python/CMakeLists.txt ===
add_subdirectory(wavelets)
if(tests)
  add_subdirectory(tests)
endif()

=== cpp/examples/CMakeLists.txt ===
add_example(wavelets LIBRARIES sopt LABELS wavelets)
add_example(sara LIBRARIES sopt LABELS wavelets)
add_example(positive_quadrant_projection LIBRARIES sopt LABELS proximals)
add_example(l1_norm LIBRARIES sopt LABELS proximals)
add_example(soft_threshhold LIBRARIES sopt LABELS proximals)
add_example(conjugate_gradient LIBRARIES sopt)
add_example(l1_proximal LIBRARIES sopt)

add_subdirectory(sdmm)
add_subdirectory(proximal_admm)

=== cpp/sopt/CMakeLists.txt ===
# list of headers
set(headers
  imaging_padmm.h logging.disabled.h maths.h proximal.h relative_variation.h sdmm.h
  wavelets.h conjugate_gradient.h l1_proximal.h logging.enabled.h padmm.h proximal_expression.h
  reweighted.h types.h wrapper.h exception.h linear_transform.h logging.h positive_quadrant.h
  real_type.h sampling.h ${PROJECT_BINARY_DIR}/include/sopt/config.h
)
set(wavelet_headers
  wavelets/direct.h wavelets/indirect.h wavelets/innards.impl.h wavelets/sara.h
  wavelets/wavelet_data.h wavelets/wavelets.h
)

set(sources wavelets/wavelets.cc wavelets/wavelet_data.cc)
if(TIFF_FOUND)
  list(APPEND sources utilities.cc)
  list(APPEND headers utilities.h)
endif()

add_library(sopt SHARED ${sources})
add_dependencies(sopt lookup_dependencies)
set(version "${Sopt_VERSION_MAJOR}.${Sopt_VERSION_MINOR}.${Sopt_VERSION_PATCH}")
set_target_properties(sopt PROPERTIES VERSION ${version} SOVERSION ${version})

target_include_directories(sopt PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..>
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:include/>)

if(TIFF_FOUND)
  target_link_libraries(sopt ${TIFF_LIBRARY})
  target_include_directories(sopt SYSTEM PUBLIC ${TIFF_INCLUDE_DIR})
endif()
# Add spdlog as direct dependency if not downloaded
if(SPDLOG_INCLUDE_DIR AND NOT spdlog_BUILT_AS_EXTERNAL_PROJECT)
  target_include_directories(sopt SYSTEM PUBLIC ${SPDLOG_INCLUDE_DIR})
elseif(SPDLOG_INCLUDE_DIR AND spdlog_BUILT_AS_EXTERNAL_PROJECT)
  target_include_directories(sopt SYSTEM PUBLIC $<BUILD_INTERFACE:${SPDLOG_INCLUDE_DIR}>)
endif()
# Add eigen as direct dependency if not downloaded
if(EIGEN3_INCLUDE_DIR AND NOT Eigen3_BUILT_AS_EXTERNAL_PROJECT)
  target_include_directories(sopt SYSTEM PUBLIC ${EIGEN3_INCLUDE_DIR})
elseif(EIGEN3_INCLUDE_DIR AND Eigen3_BUILT_AS_EXTERNAL_PROJECT)
  target_include_directories(sopt SYSTEM PUBLIC $<BUILD_INTERFACE:${EIGEN3_INCLUDE_DIR}>)
endif()
if(TARGET openmp::openmp)
  target_link_libraries(sopt openmp::openmp)
endif()

install(FILES ${headers} DESTINATION include/sopt)
install(FILES ${wavelet_headers} DESTINATION include/sopt/wavelets)
install(TARGETS sopt
  EXPORT SoptCPPTargets
  DESTINATION share/cmake/sopt
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  INCLUDES DESTINATION include
)

=== cpp/tests/CMakeLists.txt ===
if(logging)
  add_library(common_catch_main_object OBJECT "common_catch_main.cc")
  if(SPDLOG_INCLUDE_DIR)
    target_include_directories(common_catch_main_object SYSTEM PUBLIC ${SPDLOG_INCLUDE_DIR})
  endif()
  if(CATCH_INCLUDE_DIR)
    target_include_directories(common_catch_main_object SYSTEM PUBLIC ${CATCH_INCLUDE_DIR})
  endif()
  target_include_directories(common_catch_main_object PUBLIC
    "${PROJECT_BINARY_DIR}/include/"
    "${CMAKE_CURRENT_SOURCE_DIR}/.."
  )
  add_dependencies(common_catch_main_object lookup_dependencies)
endif()

add_catch_test(wavelets LIBRARIES sopt)
add_catch_test(sara LIBRARIES sopt)
add_catch_test(maths LIBRARIES sopt)
add_catch_test(wrapper LIBRARIES sopt)
add_catch_test(conjugate_gradient LIBRARIES sopt)
add_catch_test(linear_transform LIBRARIES sopt)
add_catch_test(sdmm LIBRARIES sopt)
add_catch_test(sdmm_warm_start LIBRARIES sopt)
add_catch_test(proximal LIBRARIES sopt)
add_catch_test_with_seed(seeded_proximal test_proximal 1449580491)
add_catch_test(padmm LIBRARIES sopt)
add_catch_test(padmm_warm_start LIBRARIES sopt)
add_catch_test(reweighted LIBRARIES sopt)
add_catch_test(power_method LIBRARIES sopt)

=== cpp/tools_for_tests/CMakeLists.txt ===
add_library(tools_for_tests STATIC tiffwrappers.cc tiffwrappers.h)
target_link_libraries(tools_for_tests ${TIFF_LIBRARY})
target_include_directories(tools_for_tests PUBLIC
  "${CMAKE_CURRENT_SOURCE_DIR}/.."
  "${PROJECT_BINARY_DIR}/include/"
)
target_include_directories(tools_for_tests SYSTEM PUBLIC ${TIFF_INCLUDE_DIR})
if(SPDLOG_INCLUDE_DIR)
  target_include_directories(tools_for_tests SYSTEM PUBLIC ${SPDLOG_INCLUDE_DIR})
endif()
if(EIGEN3_INCLUDE_DIR)
  target_include_directories(tools_for_tests SYSTEM PUBLIC ${EIGEN3_INCLUDE_DIR})
endif()
add_dependencies(tools_for_tests lookup_dependencies)

# Simple manual tester of read/write tiff
add_executable(copy_tiff copy_tiff.cc)
target_link_libraries(copy_tiff tools_for_tests sopt)

configure_file("directories.in.h" "${PROJECT_BINARY_DIR}/include/tools_for_tests/directories.h")
file(MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/outputs")
file(MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/outputs/sdmm")
file(MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/outputs/sdmm/regressions")

=== python/tests/CMakeLists.txt ===
add_pytest(test_*.py)

=== python/wavelets/CMakeLists.txt ===
include_directories(SYSTEM ${PYTHON_INCLUDE_DIR} ${NUMPY_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

add_python_module(sopt CPP TARGETNAME pywavelets LIBRARIES sopt FAKE_INIT wavelets.pyx)

=== cpp/examples/proximal_admm/CMakeLists.txt ===
add_example(padmm_euclidian_norm euclidian_norm.cc LIBRARIES sopt LABELS padmm)
set_target_properties(example_padmm_euclidian_norm PROPERTIES OUTPUT_NAME euclidian_norm)
add_example(padmm_inpainting inpainting.cc LIBRARIES sopt tools_for_tests)
set_target_properties(example_padmm_inpainting PROPERTIES OUTPUT_NAME inpainting)
add_example(padmm_reweighted reweighted.cc LIBRARIES sopt tools_for_tests)
set_target_properties(example_padmm_reweighted PROPERTIES OUTPUT_NAME reweighted)

=== cpp/examples/sdmm/CMakeLists.txt ===
add_example(euclidian_norm LIBRARIES sopt LABELS sdmm)
add_example(inpainting LIBRARIES sopt tools_for_tests LABELS sdmm)
add_example(reweighted LIBRARIES sopt tools_for_tests LABELS sdmm)

=== debian/changelog ===
sopt (2.0.0-4) unstable; urgency=medium

  * Disable power_method test
  * Push Standards-Version to 4.1.3. No changes needed.

 -- Ole Streicher <olebole@debian.org>  Sat, 30 Dec 2017 14:05:24 +0100

sopt (2.0.0-3) unstable; urgency=medium

  * Logging api changed. Disabling colors for now. (Closes: #884219)
  * Push Standards-Version to 4.1.2. Use https in all urls

 -- Ole Streicher <olebole@debian.org>  Tue, 12 Dec 2017 21:27:02 +0100

sopt (2.0.0-2) unstable; urgency=low

  * Remove unneeded pandas dependency

 -- Ole Streicher <olebole@debian.org>  Wed, 07 Dec 2016 11:50:40 +0100

sopt (2.0.0-1) unstable; urgency=low

  * Initial release. (Closes: #832659)

 -- Ole Streicher <olebole@debian.org>  Tue, 11 Oct 2016 20:10:08 +0200

=== debian/control ===
Source: sopt
Section: science
Priority: optional
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Gijs Molenaar <gijs@pythonic.nl>, Ole Streicher <olebole@debian.org>
Build-Depends: catch,
               cmake,
               cython,
               debhelper (>= 9),
               libblas-dev,
               libeigen3-dev,
               libspdlog-dev,
               libtiff5-dev,
               python,
               python-numpy,
               python-pytest,
               python-scipy,
	       python-setuptools
Standards-Version: 4.1.3
Vcs-Git: https://anonscm.debian.org/git/debian-astro/packages/sopt.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-astro/packages/sopt.git
Homepage: https://basp-group.github.io/sopt/

Package: libsopt2.0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Section: libs
Description: Sparse OPTimisation shared library
 SOPT is a C package to perform Sparse OPTimisation.  It solves a
 variety of sparse regularisation problems, including the SARA
 algorithm.
 .
 SOPT is largely provided to support the PURIFY package, a companion
 open-source code to perform radio interferometric imaging, also
 written by the authors of SOPT.
 .
 This package contains the shared library.

Package: libsopt-dev
Architecture: any
Section: libdevel
Depends: libsopt2.0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Development package for Sparse OPTimisation library
 SOPT is a C package to perform Sparse OPTimisation.  It solves a
 variety of sparse regularisation problems, including the SARA
 algorithm.
 .
 SOPT is largely provided to support the PURIFY package, a companion
 open-source code to perform radio interferometric imaging, also
 written by the authors of SOPT.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CMAKE_FLAGS += -DDEB_BUILD_MULTIARCH=`dpkg-architecture -qDEB_BUILD_MULTIARCH`

%:
	dh $@ --parallel --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/sopt-$1\.tar\.gz/ \
  https://github.com/basp-group/sopt/tags .*/v?(\d\S*)\.tar\.gz

## sopt 3.0.1

=== cpp/CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,7 @@
 configure_file(sopt/config.in.h "${PROJECT_BINARY_DIR}/include/sopt/config.h")
 
 add_subdirectory(sopt)
-if(regressions OR examples)
+if(regressions OR examples OR tests)
   # Tiff wrappers and whatnot
   add_subdirectory(tools_for_tests)
 endif()
@@ -36,3 +36,6 @@
 if(regressions)
   add_subdirectory(regressions)
 endif()
+if (docs)
+  add_subdirectory(docs)
+endif()

=== cpp/docs/CMakeLists.txt ===
# Set some Doxygen flags
set(SOPT_DOXY_PROJECT_NAME "SOPT")
set(SOPT_DOXY_PROJECT_BRIEF "Sparse OPTimisation")
set(SOPT_DOXY_INPUT "${PROJECT_SOURCE_DIR}/cpp")

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
  ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
)

file(COPY
  ${CMAKE_CURRENT_SOURCE_DIR}/DoxygenLayout.xml
  DESTINATION ${CMAKE_CURRENT_BINARY_DIR}
)


add_custom_target(doc ALL
  COMMAND doxygen
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

if (web)
   add_custom_target(docweb
     COMMAND sed -i -e 's@namespacesopt@http://astro-informatics.github.io/sopt/&@g' -e 's@<filename>@&http://astro-informatics.github.io/sopt/@g' ${CMAKE_CURRENT_BINARY_DIR}/html/sopt.tag
     DEPENDS doc)
endif()

=== cpp/examples/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,9 @@
 add_example(soft_threshhold LIBRARIES sopt LABELS proximals)
 add_example(conjugate_gradient LIBRARIES sopt)
 add_example(l1_proximal LIBRARIES sopt)
+add_example(power_method LIBRARIES sopt)
 
 add_subdirectory(sdmm)
 add_subdirectory(proximal_admm)
+add_subdirectory(primal_dual)
+add_subdirectory(forward_backward)

=== cpp/examples/forward_backward/CMakeLists.txt ===
add_example(forward_backward_inpainting inpainting.cc LIBRARIES sopt tools_for_tests)
set_target_properties(example_forward_backward_inpainting PROPERTIES OUTPUT_NAME inpainting)
add_example(forward_backward_inpainting_joint_map inpainting_joint_map.cc LIBRARIES sopt tools_for_tests)
set_target_properties(example_forward_backward_inpainting_joint_map PROPERTIES OUTPUT_NAME inpainting_joint_map)
add_example(forward_backward_inpainting_credible_interval inpainting_credible_interval.cc LIBRARIES sopt tools_for_tests NOTEST)
set_target_properties(example_forward_backward_inpainting_credible_interval PROPERTIES OUTPUT_NAME inpainting_credible_interval)

=== cpp/examples/primal_dual/CMakeLists.txt ===
add_example(pd_inpainting inpainting.cc LIBRARIES sopt tools_for_tests LABELS pd)
set_target_properties(example_pd_inpainting PROPERTIES OUTPUT_NAME inpainting)
add_example(pd_reweighted NOTEST reweighted.cc LIBRARIES sopt tools_for_tests LABELS pd)
set_target_properties(example_pd_reweighted PROPERTIES OUTPUT_NAME reweighted)

=== debian/changelog ===
sopt (3.0.1-11) unstable; urgency=medium

  [ Shengjing Zhu ]
  * Add patch to fix FTBFS with spdlog (Closes: #975843)

  [ Ole Streicher ]
  * Fix e-mail address of uploader for 3.0.1-9
  * Push Standards-Version to 4.5.1. No changes needed
  * Push dh-compat to 13
  * Add "Rules-Requires-Root: no" to d/control
  * Use Expat short name instead MIT in d/copyright

 -- Ole Streicher <olebole@debian.org>  Wed, 16 Dec 2020 10:00:24 +0100

sopt (3.0.1-10) unstable; urgency=medium

  * Disable mpi_proximals test

 -- Ole Streicher <olebole@debian.org>  Wed, 06 Nov 2019 12:00:39 +0100

sopt (3.0.1-9) unstable; urgency=medium

  * Add libopenmpi-dev dependency to libsopt-dev (Closes: #943812)
    Keep the build dependency as well.

 -- Ole Streicher <olebole@debian.org>  Sun, 03 Nov 2019 14:27:10 +0100

sopt (3.0.1-8) unstable; urgency=medium

  * Add libopenmpi-dev build dependency

 -- Ole Streicher <olebole@debian.org>  Fri, 01 Nov 2019 12:50:31 +0100

sopt (3.0.1-7) unstable; urgency=low

  * Add MPI support
  * Push Standards-Version to 4.4.1. No changes needed

 -- Ole Streicher <olebole@debian.org>  Mon, 21 Oct 2019 10:17:37 +0200

sopt (3.0.1-6) unstable; urgency=low

  * Further increase tolerance for mips

 -- Ole Streicher <olebole@debian.org>  Fri, 27 Sep 2019 13:30:09 +0200

sopt (3.0.1-5) unstable; urgency=low

  * Increase tolerance in test_proximal to fix FTBFS on mips

 -- Ole Streicher <olebole@debian.org>  Fri, 27 Sep 2019 10:34:50 +0200

sopt (3.0.1-4) unstable; urgency=low

  * Fix FTBFS on i386

 -- Ole Streicher <olebole@debian.org>  Fri, 27 Sep 2019 08:53:12 +0200

sopt (3.0.1-3) unstable; urgency=low

  [ Helmut Grohne ]
  * Fix build/host confusion (Closes: #941037)

  [ Ole Streicher ]
  * Mark shared lib as Multi-Arch:same

 -- Ole Streicher <olebole@debian.org>  Wed, 25 Sep 2019 10:14:38 +0200

sopt (3.0.1-2) unstable; urgency=low

  * Switch to unstable to start transition
  * Fix test_credible_region on i386

 -- Ole Streicher <olebole@debian.org>  Fri, 20 Sep 2019 11:30:50 +0200

sopt (3.0.1-1) experimental; urgency=medium

  * Update github organization name
  * Remove unused Python build dependencies (Closes: #938514)
  * Push Standards-Version to 4.4.0. No changes needed.
  * Push compat to 12. Remove d/compat
  * Add gitlab-ci.yml for salsa
  * New upstream version 3.0.1. Rediff patches
  * Update SOVERSION. Switch to experimental to prepare transition.

 -- Ole Streicher <olebole@debian.org>  Fri, 30 Aug 2019 12:25:00 +0200

sopt (2.0.0-5) unstable; urgency=medium

  * Update VCS fields to use salsa.d.o
  * Add spdlog header (Closes: #909765)
  * Push Standards-Version to 4.2.1. No changes needed
  * Push compat to 11

 -- Ole Streicher <olebole@debian.org>  Sun, 30 Sep 2018 10:42:13 +0200

=== debian/control ===
--- 
+++ 
@@ -5,24 +5,22 @@
 Uploaders: Gijs Molenaar <gijs@pythonic.nl>, Ole Streicher <olebole@debian.org>
 Build-Depends: catch,
                cmake,
-               cython,
-               debhelper (>= 9),
+               debhelper-compat (= 13),
                libblas-dev,
                libeigen3-dev,
+               libopenmpi-dev,
                libspdlog-dev,
                libtiff5-dev,
-               python,
-               python-numpy,
-               python-pytest,
-               python-scipy,
-	       python-setuptools
-Standards-Version: 4.1.3
-Vcs-Git: https://anonscm.debian.org/git/debian-astro/packages/sopt.git
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-astro/packages/sopt.git
-Homepage: https://basp-group.github.io/sopt/
+               mpi-default-dev
+Standards-Version: 4.5.0
+Vcs-Git: https://salsa.debian.org/debian-astro-team/sopt.git
+Vcs-Browser: https://salsa.debian.org/debian-astro-team/sopt
+Homepage: https://astro-informatics.github.io/sopt/
+Rules-Requires-Root: no
 
-Package: libsopt2.0
+Package: libsopt3.0
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Section: libs
 Description: Sparse OPTimisation shared library
@@ -39,7 +37,10 @@
 Package: libsopt-dev
 Architecture: any
 Section: libdevel
-Depends: libsopt2.0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: libopenmpi-dev,
+         libsopt3.0 (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Description: Development package for Sparse OPTimisation library
  SOPT is a C package to perform Sparse OPTimisation.  It solves a
  variety of sparse regularisation problems, including the SARA

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CMAKE_FLAGS += -DDEB_HOST_MULTIARCH=`dpkg-architecture -qDEB_HOST_MULTIARCH`

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/sopt-$1\.tar\.gz/ \
  https://github.com/astro-informatics/sopt/tags .*/v?(\d\S*)\.tar\.gz

## sopt 3.0.1%2Bdfsg

=== cpp/sopt/CMakeLists.txt ===
--- 
+++ 
@@ -1,25 +1,34 @@
 # list of headers
 set(headers
-  imaging_padmm.h logging.disabled.h maths.h proximal.h relative_variation.h sdmm.h
+  bisection_method.h chained_operators.h credible_region.h
+  primal_dual.h imaging_padmm.h logging.disabled.h 
+  forward_backward.h imaging_forward_backward.h
+  joint_map.h
+  maths.h proximal.h relative_variation.h sdmm.h
   wavelets.h conjugate_gradient.h l1_proximal.h logging.enabled.h padmm.h proximal_expression.h
   reweighted.h types.h wrapper.h exception.h linear_transform.h logging.h positive_quadrant.h
-  real_type.h sampling.h ${PROJECT_BINARY_DIR}/include/sopt/config.h
-)
+  real_type.h sampling.h power_method.h objective_functions.h ${PROJECT_BINARY_DIR}/include/sopt/config.h
+  )
 set(wavelet_headers
   wavelets/direct.h wavelets/indirect.h wavelets/innards.impl.h wavelets/sara.h
   wavelets/wavelet_data.h wavelets/wavelets.h
-)
+  )
 
 set(sources wavelets/wavelets.cc wavelets/wavelet_data.cc)
 if(TIFF_FOUND)
   list(APPEND sources utilities.cc)
   list(APPEND headers utilities.h)
 endif()
+if(SOPT_MPI)
+  list(APPEND sources mpi/communicator.cc mpi/registered_types.cc mpi/session.cc wavelets/sara.cc)
+  list(APPEND mpi_headers mpi/communicator.h mpi/registered_types.h mpi/utilities.h mpi/session.h)
+endif()
 
 add_library(sopt SHARED ${sources})
 add_dependencies(sopt lookup_dependencies)
 set(version "${Sopt_VERSION_MAJOR}.${Sopt_VERSION_MINOR}.${Sopt_VERSION_PATCH}")
-set_target_properties(sopt PROPERTIES VERSION ${version} SOVERSION ${version})
+set(soversion "${Sopt_VERSION_MAJOR}.${Sopt_VERSION_MINOR}")
+set_target_properties(sopt PROPERTIES VERSION ${version} SOVERSION ${soversion})
 
 target_include_directories(sopt PUBLIC
   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..>
@@ -45,13 +54,18 @@
 if(TARGET openmp::openmp)
   target_link_libraries(sopt openmp::openmp)
 endif()
+if(SOPT_MPI)
+  target_link_libraries(sopt ${MPI_CXX_LIBRARIES})
+  target_include_directories(sopt SYSTEM PUBLIC ${MPI_CXX_INCLUDE_PATH})
+endif()
 
 install(FILES ${headers} DESTINATION include/sopt)
 install(FILES ${wavelet_headers} DESTINATION include/sopt/wavelets)
+install(FILES ${mpi_headers} DESTINATION include/sopt/mpi)
 install(TARGETS sopt
   EXPORT SoptCPPTargets
   DESTINATION share/cmake/sopt
   LIBRARY DESTINATION lib
   ARCHIVE DESTINATION lib
   INCLUDES DESTINATION include
-)
+  )

## sopt 3.0.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(Sopt CXX)

# Location of extra cmake includes for the project
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_files)
# Downloads and installs GreatCMakeCookOff
# It contains a number of cmake recipes
include(LookUp-GreatCMakeCookOff)

# Version and git hash id
include(VersionAndGitRef)
set_version(3.0.1)
get_gitref()

option(tests          "Enable testing"                         on)
option(benchmarks     "Enable benchmarking"                    off)
option(examples       "Enable Examples"                        on)
option(logging        "Enable logging"                         on)
option(regressions    "Enable regressions"                     off)
option(openmp         "Enable OpenMP"                          on)
option(dompi          "Enable MPI"                             on)
option(docs           "Build documentation"                    off)
option(coverage       "Build coverage"                         off)

if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build Type" FORCE)
endif()
message(STATUS "Building sopt in ${CMAKE_BUILD_TYPE} mode")

if(regressions)
  enable_language(C)
endif()
if(tests)
  enable_testing()
endif()

# Add c++11 stuff
include(AddCPP11Flags)
include(CheckCXX11Features)
cxx11_feature_check(REQUIRED unique_ptr nullptr override constructor_delegate)
include(compilations)

# search/install dependencies
include(dependencies)

# sets rpath policy explicitly
if(CMAKE_VERSION VERSION_LESS 3.0)
    set_property(GLOBAL PROPERTY MACOSX_RPATH ON)
else()
    cmake_policy(SET CMP0042 NEW)
endif()

if(SOPT_MPI)
  include(DetectIntegerArchitecture)
  DetectIntegerArchitecture(SOPT)
endif()


if(tests OR examples)
  enable_testing()
endif()

if(tests)
  include(AddCatchTest)
endif()
if(examples)
  include(AddExample)
endif()

if(benchmarks)
  set(GBenchmark_GIT_TAG "v1.3.0")
  include(AddBenchmark)
endif()
if(regressions)
  include(AddRegression)
endif()
if(tests AND coverage)
  # Enable code coverage.
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")

	# Build with debugging information to make the output meaningful.
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")

	# Disable optimizations to get the most accurate results.
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0")
endif()

add_subdirectory(cpp)

# Exports all Sopt so other packages can access it
include(export_sopt)

=== cpp/benchmarks/CMakeLists.txt ===
add_benchmark(wavelets LIBRARIES sopt)
add_benchmark(conjugate_gradient LIBRARIES sopt)
add_benchmark(l1_proximal LIBRARIES sopt)

=== cpp/regressions/CMakeLists.txt ===
add_regression(sdmm_inpainting LABELS sdmm LIBRARIES tools_for_tests sopt)
add_regression(l1_proximal LABELS sdmm LIBRARIES sopt tools_for_tests sopt)
add_regression(padmm_inpainting LABELS sdmm LIBRARIES tools_for_tests sopt)
add_regression(reweighted_sdmm LABELS sdmm LIBRARIES tools_for_tests sopt)

=== cpp/tests/CMakeLists.txt ===
--- 
+++ 
@@ -9,8 +9,11 @@
   target_include_directories(common_catch_main_object PUBLIC
     "${PROJECT_BINARY_DIR}/include/"
     "${CMAKE_CURRENT_SOURCE_DIR}/.."
-  )
+    )
   add_dependencies(common_catch_main_object lookup_dependencies)
+endif()
+if(CATCH_HAS_THROWS_AS)
+  add_definitions(-DCATCH_HAS_THROWS_AS)
 endif()
 
 add_catch_test(wavelets LIBRARIES sopt)
@@ -19,11 +22,57 @@
 add_catch_test(wrapper LIBRARIES sopt)
 add_catch_test(conjugate_gradient LIBRARIES sopt)
 add_catch_test(linear_transform LIBRARIES sopt)
+add_catch_test(chained_operators LIBRARIES sopt)
 add_catch_test(sdmm LIBRARIES sopt)
 add_catch_test(sdmm_warm_start LIBRARIES sopt)
 add_catch_test(proximal LIBRARIES sopt)
 add_catch_test_with_seed(seeded_proximal test_proximal 1449580491)
 add_catch_test(padmm LIBRARIES sopt)
+add_catch_test(forward_backward LIBRARIES sopt tools_for_tests)
 add_catch_test(padmm_warm_start LIBRARIES sopt)
 add_catch_test(reweighted LIBRARIES sopt)
 add_catch_test(power_method LIBRARIES sopt)
+add_catch_test(primal_dual LIBRARIES sopt)
+add_catch_test(credible_region LIBRARIES sopt)
+add_catch_test(bisection_method LIBRARIES sopt)
+
+if(SOPT_MPI)
+  add_library(common_mpi_catch_main_object OBJECT common_mpi_catch_main.cc)
+  add_dependencies(common_mpi_catch_main_object lookup_dependencies)
+  target_include_directories(common_mpi_catch_main_object
+    PUBLIC ${PROJECT_SOURCE_DIR}/cpp ${PROJECT_BINARY_DIR}/include ${MPI_CXX_INCLUDE_PATH})
+  if(SPDLOG_INCLUDE_DIR)
+    target_include_directories(common_mpi_catch_main_object SYSTEM PUBLIC ${SPDLOG_INCLUDE_DIR})
+  endif()
+  if(CATCH_INCLUDE_DIR)
+    target_include_directories(common_mpi_catch_main_object SYSTEM PUBLIC ${CATCH_INCLUDE_DIR})
+  endif()
+
+  function(add_mpi_test_from_test testname)
+    unset(arguments)
+    if(CATCH_JUNIT)
+      set(arguments -r junit -o ${PROJECT_BINARY_DIR}/Testing/${testname}.xml)
+    endif()
+    if(NOT MPIEXEC_MAX_NUMPROCS)
+      set(MPIEXEC_MAX_NUMPROCS 4)
+    endif()
+    add_test(NAME ${testname}
+      COMMAND
+      ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} ${MPIEXEC_MAX_NUMPROCS} ${MPIEXEC_PREFLAGS}
+      $<TARGET_FILE:test_${testname}> ${arguments})
+    set_tests_properties(${testname} PROPERTIES LABELS "catch;mpi")
+  endfunction()
+
+  function(add_mpi_test testname)
+    add_catch_test(${testname} COMMON_MAIN common_mpi_catch_main_object NOTEST ${ARGN})
+    add_mpi_test_from_test(${testname})
+  endfunction()
+
+  add_mpi_test(communicator LIBRARIES sopt)
+  add_mpi_test(mpi_proximals LIBRARIES sopt)
+  add_mpi_test(serial_vs_parallel_padmm LIBRARIES sopt tools_for_tests)
+  add_mpi_test(mpi_wavelets LIBRARIES sopt)
+
+  add_catch_test(mpi_session NOMAIN LIBRARIES sopt NOTEST)
+  add_mpi_test_from_test(mpi_session)
+endif()

=== cpp/examples/proximal_admm/CMakeLists.txt ===
add_example(padmm_euclidian_norm euclidian_norm.cc LIBRARIES sopt LABELS padmm)
set_target_properties(example_padmm_euclidian_norm PROPERTIES OUTPUT_NAME euclidian_norm)
add_example(padmm_inpainting inpainting.cc LIBRARIES sopt tools_for_tests)
set_target_properties(example_padmm_inpainting PROPERTIES OUTPUT_NAME inpainting)
add_example(padmm_reweighted NOTEST reweighted.cc LIBRARIES sopt tools_for_tests)
set_target_properties(example_padmm_reweighted PROPERTIES OUTPUT_NAME reweighted)

=== debian/changelog ===
sopt (3.0.1+dfsg-1) unstable; urgency=medium

  [ Shengjing Zhu ]
  * Add workaround for fmtlib 9 (Closes: #1014685)

  [ Ole Streicher ]
  * Exclude matplotlib files from upstream distribution
  * Adjusted upstream version 3.0.1+dfsg
  * Push Standards-Version to 4.6.1. No changes needed

 -- Ole Streicher <olebole@debian.org>  Fri, 05 Aug 2022 11:44:04 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: sopt
+Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
+Uploaders: Gijs Molenaar <gijs@pythonic.nl>,
+           Ole Streicher <olebole@debian.org>
 Section: science
 Priority: optional
-Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
-Uploaders: Gijs Molenaar <gijs@pythonic.nl>, Ole Streicher <olebole@debian.org>
 Build-Depends: catch,
                cmake,
                debhelper-compat (= 13),
@@ -12,17 +13,18 @@
                libspdlog-dev,
                libtiff5-dev,
                mpi-default-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
+Vcs-Browser: https://salsa.debian.org/debian-astro-team/sopt
 Vcs-Git: https://salsa.debian.org/debian-astro-team/sopt.git
-Vcs-Browser: https://salsa.debian.org/debian-astro-team/sopt
 Homepage: https://astro-informatics.github.io/sopt/
 Rules-Requires-Root: no
 
 Package: libsopt3.0
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, ${shlibs:Depends}
 Section: libs
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
 Description: Sparse OPTimisation shared library
  SOPT is a C package to perform Sparse OPTimisation.  It solves a
  variety of sparse regularisation problems, including the SARA

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg//,repacksuffix=+dfsg,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/sopt-$1\.tar\.gz/ \
  https://github.com/astro-informatics/sopt/tags .*/v?(\d\S*)\.tar\.gz

## sopt 4.1.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.4) # CMake 3.13.4 is the currently default in Debian 10 repositories

# Do not allow in-source builds.
if(PROJECT_SOURCE_DIR STREQUAL PROJECT_BINARY_DIR)
	message(FATAL_ERROR "In-source builds are not allowed!\nCreate a \"build\" dir and remove:\n- ${CMAKE_SOURCE_DIR}/CMakeCache.txt\n- ${CMAKE_SOURCE_DIR}/CMakeFiles")
endif()

project(sopt
        DESCRIPTION "Sparse OPTimisation using state-of-the-art convex optimisation algorithms."
        HOMEPAGE_URL "http://astro-informatics.github.io/sopt/"
        LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# https://cmake.org/cmake/help/latest/variable/CMAKE_EXPORT_COMPILE_COMMANDS.html
# Enable output of compile commands during generation. If enabled, generates a compile_commands.json file containing the exact compiler calls for all translation units of the project in machine-readable form. This can be consumed by various IDEs and static analysers to provide smarter project diagnostics/completions etc.
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# https://stackoverflow.com/a/67410042
# Create a symlink to compile_commands.json located in CMAKE_BINARY_DIR to the project root (works across filesystems)
execute_process(
  COMMAND ${CMAKE_COMMAND} -E create_symlink
  ${CMAKE_BINARY_DIR}/compile_commands.json
  ${CMAKE_SOURCE_DIR}/compile_commands.json)

# Location of extra cmake includes for the project
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_files)
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/build)

# Version and git hash id
find_package(Git)

# Set version variable
set(SOPT_VERSION 3.1.0)

# If git is found and this is a git workdir, then figure out build id
# Stores results in SOPT_VERSION and SOPT_GITREF
if(GIT_FOUND)
  execute_process(
    COMMAND ${GIT_EXECUTABLE} rev-parse HEAD
    RESULT_VARIABLE HASH_RESULT
    OUTPUT_VARIABLE GIT_HASH
    ERROR_QUIET
  )
  if(HASH_RESULT EQUAL 0)
    string(STRIP "${GIT_HASH}" GIT_HASH)
  else()
    set(GIT_HASH "NA")
  endif()
else()
  set(GIT_HASH "NA")
endif()

set(SOPT_GITREF ${GIT_HASH})


option(tests          "Enable testing"                         on)
option(benchmarks     "Enable benchmarking"                    off)
option(examples       "Enable Examples"                        on)
option(openmp         "Enable OpenMP"                          on)
option(dompi          "Enable MPI"                             on)
option(docs           "Build documentation"                    off)
option(coverage       "Build coverage"                         off)
option(onnxrt         "Enable ONNXruntime interface"           off)
option(cppflow        "Enable tensorflow integration"          off)

if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build Type" FORCE)
endif()
message(STATUS "Building sopt in ${CMAKE_BUILD_TYPE} mode")

if(tests OR examples)
  enable_testing()
endif()


include(compilations)

# search/install dependencies
include(dependencies)

# sets rpath policy explicitly
if(CMAKE_VERSION VERSION_LESS 3.0)
    set_property(GLOBAL PROPERTY MACOSX_RPATH ON)
else()
    cmake_policy(SET CMP0042 NEW)
endif()

if(SOPT_MPI)
  include(DetectIntegerArchitecture)
  DetectIntegerArchitecture(SOPT)
endif()

if(tests)
  find_package(Catch2)
  include(AddCatchTest)
endif()

if(examples)
  include(AddExample)
endif()

if(benchmarks)
  set(GBenchmark_GIT_TAG "v1.3.0")
  include(AddBenchmark)
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-command-line-argument")

if(tests AND coverage)
  # Enable code coverage.
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")

	# Build with debugging information to make the output meaningful.
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")

	# Disable optimizations to get the most accurate results.
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0")
endif()

add_subdirectory(cpp)

# Exports all Sopt so other packages can access it
include(export_sopt)

=== cpp/sopt/CMakeLists.txt ===
# list of headers
set(headers
  bisection_method.h chained_operators.h credible_region.h
  imaging_padmm.h logging.h
  forward_backward.h imaging_forward_backward.h
  g_proximal.h l1_g_proximal.h joint_map.h
  imaging_primal_dual.h primal_dual.h
  maths.h proximal.h relative_variation.h sdmm.h
  wavelets.h conjugate_gradient.h l1_proximal.h padmm.h proximal_expression.h
  reweighted.h types.h wrapper.h exception.h linear_transform.h positive_quadrant.h
  tv_primal_dual.h gradient_operator.h
  l2_forward_backward.h l2_primal_dual.h
  real_type.h sampling.h power_method.h objective_functions.h ${PROJECT_BINARY_DIR}/include/sopt/config.h
)

set(wavelet_headers
  wavelets/direct.h wavelets/indirect.h wavelets/innards.impl.h wavelets/sara.h
  wavelets/wavelet_data.h wavelets/wavelets.h
)

set(sources logging.cc wavelets/wavelets.cc wavelets/wavelet_data.cc)

if(TIFF_FOUND)
  list(APPEND sources utilities.cc)
  list(APPEND headers utilities.h)
endif()

if(SOPT_MPI)
  list(APPEND sources mpi/communicator.cc mpi/registered_types.cc mpi/session.cc)
  list(APPEND mpi_headers mpi/communicator.h mpi/registered_types.h mpi/utilities.h mpi/session.h)
endif()

if(onnxrt)
  list(APPEND headers ort_session.h)
endif()

if(cppflow)
  list(APPEND sources cppflow_utils.cc)
  list(APPEND headers cppflow_utils.h tf_g_proximal.h)
endif()

add_library(sopt SHARED ${sources})
set(version "${SOPT_VERSION_MAJOR}.${SOPT_VERSION_MINOR}.${SOPT_VERSION_PATCH}")
set(soversion "${SOPT_VERSION_MAJOR}.${SOPT_VERSION_MINOR}")
set_target_properties(sopt PROPERTIES VERSION ${version} SOVERSION ${soversion})

target_include_directories(sopt PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..>
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:include/>)

if(TIFF_FOUND)
  target_link_libraries(sopt TIFF::TIFF)
  target_include_directories(sopt SYSTEM PUBLIC ${TIFF_INCLUDE_DIR})
endif()

if(EIGEN3_INCLUDE_DIR)
  target_include_directories(sopt SYSTEM PUBLIC ${EIGEN3_INCLUDE_DIR})
endif()

if(SOPT_OPENMP)
  target_link_libraries(sopt OpenMP::OpenMP_CXX)
endif()

if(SOPT_MPI)
  target_link_libraries(sopt ${MPI_CXX_LIBRARIES})
  target_include_directories(sopt SYSTEM PUBLIC ${MPI_CXX_INCLUDE_PATH})
endif()

if(onnxrt)
  target_link_libraries(sopt ${onnxruntime_LIBRARIES})
  target_include_directories(sopt SYSTEM PUBLIC ${onnxruntime_INCLUDE_DIR})
endif()

if (cppflow)
  target_link_libraries(sopt "${TENSORFLOW_LIB}")
  # Make cppflow include directory public. Install interface can't point to source directory,
  # so it needs to be separately defined, explained in
  # https://stackoverflow.com/questions/25676277/cmake-target-include-directories-prints-an-error-when-i-try-to-add-the-source
  # Add /usr/local/include for default location of TensorFlow headers
  target_include_directories(sopt PUBLIC
    $<BUILD_INTERFACE:${cppflow_INCLUDE_DIR}>
    $<BUILD_INTERFACE:/usr/local/include>
    $<INSTALL_INTERFACE:cppflow/include/>
    )
endif()


target_link_libraries(sopt ${CONAN_LIBS})

install(FILES ${headers} DESTINATION include/sopt)
install(FILES ${wavelet_headers} DESTINATION include/sopt/wavelets)
install(FILES ${mpi_headers} DESTINATION include/sopt/mpi)
install(TARGETS sopt
  EXPORT soptCPPTargets
  DESTINATION share/cmake/sopt
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  INCLUDES DESTINATION include
)

=== cpp/tests/CMakeLists.txt ===
add_library(common_catch_main_object OBJECT "common_catch_main.cc")

if(Catch2_FOUND)
  target_link_libraries(common_catch_main_object Catch2::Catch2)
endif()

if(EIGEN3_INCLUDE_DIR)
  target_include_directories(common_catch_main_object SYSTEM PUBLIC ${EIGEN3_INCLUDE_DIR})
endif()

if(onnxruntime_INCLUDE_DIR)
  target_include_directories(common_catch_main_object SYSTEM PUBLIC ${onnxruntime_INCLUDE_DIR})
endif()

target_include_directories(common_catch_main_object PUBLIC
  "${EXTERNAL_ROOT}/include/"
  "${PROJECT_BINARY_DIR}/include/"
  "${CMAKE_CURRENT_SOURCE_DIR}/.."
)

if(CATCH_HAS_THROWS_AS)
  add_definitions(-DCATCH_HAS_THROWS_AS)
endif()

set(RAND_SEED "1449580491")

add_catch_test(bisection_method LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(chained_operators LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(conjugate_gradient LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(credible_region LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(forward_backward LIBRARIES sopt tools_for_tests SEED ${RAND_SEED})
add_catch_test(gradient_operator LIBRARIES sopt tools_for_tests SEED ${RAND_SEED})
add_catch_test(inpainting LIBRARIES sopt tools_for_tests SEED ${RAND_SEED})
add_catch_test(linear_transform LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(maths LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(padmm LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(padmm_warm_start LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(power_method LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(primal_dual LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(proximal LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(reweighted LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(sara LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(sdmm LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(sdmm_warm_start LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(wavelets LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(wrapper LIBRARIES sopt SEED ${RAND_SEED})

if(onnxrt)
  add_catch_test(ort_model LIBRARIES sopt onnxruntime::onnxruntime)
endif()

if(cppflow)
  add_catch_test(cppflow_model LIBRARIES sopt tools_for_tests)
  add_catch_test(tf_inpainting LIBRARIES sopt tools_for_tests SEED ${RAND_SEED})
endif()

if(SOPT_MPI)
  add_library(common_mpi_catch_main_object OBJECT common_mpi_catch_main.cc)

  target_include_directories(common_mpi_catch_main_object
    PUBLIC ${PROJECT_SOURCE_DIR}/cpp ${PROJECT_BINARY_DIR}/include ${MPI_CXX_INCLUDE_PATH})

  if(Catch2_FOUND)
    target_link_libraries(common_mpi_catch_main_object Catch2::Catch2)
  endif()

  if(EIGEN3_INCLUDE_DIR)
    target_include_directories(common_mpi_catch_main_object SYSTEM PUBLIC ${EIGEN3_INCLUDE_DIR})
  endif()

  function(add_mpi_test_from_test testname)
    unset(arguments)
    if(CATCH_JUNIT)
      set(arguments -r junit -o ${PROJECT_BINARY_DIR}/Testing/${testname}.xml)
    endif()
    if(NOT MPIEXEC_MAX_NUMPROCS)
      set(MPIEXEC_MAX_NUMPROCS 4)
    endif()
    add_test(NAME ${testname}
      COMMAND
      ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} ${MPIEXEC_MAX_NUMPROCS} ${MPIEXEC_PREFLAGS}
      $<TARGET_FILE:test_${testname}> ${arguments})
    set_tests_properties(${testname} PROPERTIES LABELS "catch;mpi")
  endfunction()

  function(add_mpi_test testname)
    add_catch_test(${testname} COMMON_MAIN common_mpi_catch_main_object NOTEST ${ARGN})
    add_mpi_test_from_test(${testname})
  endfunction()

  add_mpi_test(communicator LIBRARIES sopt)
  add_mpi_test(mpi_proximals LIBRARIES sopt)
  add_mpi_test(serial_vs_parallel_padmm LIBRARIES sopt tools_for_tests)
  add_mpi_test(mpi_wavelets LIBRARIES sopt)

  add_catch_test(mpi_session NOMAIN LIBRARIES sopt NOTEST)
  add_mpi_test_from_test(mpi_session)
endif()

=== cpp/examples/forward_backward/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,7 @@
 add_example(forward_backward_inpainting inpainting.cc LIBRARIES sopt tools_for_tests)
 set_target_properties(example_forward_backward_inpainting PROPERTIES OUTPUT_NAME inpainting)
+add_example(forward_backward_l2_inpainting l2_inpainting.cc LIBRARIES sopt tools_for_tests)
+set_target_properties(example_forward_backward_l2_inpainting PROPERTIES OUTPUT_NAME l2_inpainting)
 add_example(forward_backward_inpainting_joint_map inpainting_joint_map.cc LIBRARIES sopt tools_for_tests)
 set_target_properties(example_forward_backward_inpainting_joint_map PROPERTIES OUTPUT_NAME inpainting_joint_map)
 add_example(forward_backward_inpainting_credible_interval inpainting_credible_interval.cc LIBRARIES sopt tools_for_tests NOTEST)

=== cpp/examples/primal_dual/CMakeLists.txt ===
add_example(pd_inpainting inpainting.cc LIBRARIES sopt tools_for_tests LABELS pd)
set_target_properties(example_pd_inpainting PROPERTIES OUTPUT_NAME inpainting)
add_example(pd_tv_inpainting tv_inpainting.cc LIBRARIES sopt tools_for_tests LABELS pd)
set_target_properties(example_pd_tv_inpainting PROPERTIES OUTPUT_NAME tv_inpainting)

=== debian/changelog ===
sopt (4.1.0+dfsg-2) unstable; urgency=medium

  * Team upload
  * Only depend on default mpi implementation (Closes: #1086913)

 -- Bastian Germann <bage@debian.org>  Tue, 26 Nov 2024 17:14:42 +0000

sopt (4.1.0+dfsg-1) unstable; urgency=medium

  * New upstream version 4.1.0+dfsg
  * Rediff patches
  * Push Standards-Version to 4.7.0. No changes needed
  * Setters can't be const (Closes: #1075526)
  * Disable tests that run too long

 -- Ole Streicher <olebole@debian.org>  Wed, 11 Sep 2024 15:58:17 +0200

sopt (3.0.1+dfsg-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062914

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 17:08:44 +0000

sopt (3.0.1+dfsg-3) unstable; urgency=medium

  * Disable communicator MPI test (fails on mips64el) (Closes: #1043377)

 -- Ole Streicher <olebole@debian.org>  Sun, 20 Aug 2023 14:59:30 +0200

sopt (3.0.1+dfsg-2) unstable; urgency=medium

  * Team upload
  * Patch: Add the missing #include <cstdint> (Closes: #1037862)

 -- Bastian Germann <bage@debian.org>  Wed, 09 Aug 2023 16:57:48 +0200

=== debian/control ===
--- 
+++ 
@@ -4,27 +4,30 @@
            Ole Streicher <olebole@debian.org>
 Section: science
 Priority: optional
-Build-Depends: catch,
+Build-Depends: dpkg-dev (>= 1.22.5),
+               catch,
                cmake,
                debhelper-compat (= 13),
                libblas-dev,
                libeigen3-dev,
-               libopenmpi-dev,
                libspdlog-dev,
                libtiff5-dev,
                mpi-default-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/sopt
 Vcs-Git: https://salsa.debian.org/debian-astro-team/sopt.git
 Homepage: https://astro-informatics.github.io/sopt/
 Rules-Requires-Root: no
 
-Package: libsopt3.0
+Package: libsopt3.0t64
 Architecture: any
 Multi-Arch: same
 Section: libs
 Depends: ${misc:Depends},
          ${shlibs:Depends}
+Breaks: libsopt3.0 (<< ${source:Version})
+Provides: ${t64:Provides}
+Replaces: libsopt3.0
 Description: Sparse OPTimisation shared library
  SOPT is a C package to perform Sparse OPTimisation.  It solves a
  variety of sparse regularisation problems, including the SARA
@@ -39,8 +42,8 @@
 Package: libsopt-dev
 Architecture: any
 Section: libdevel
-Depends: libopenmpi-dev,
-         libsopt3.0 (= ${binary:Version}),
+Depends: mpi-default-dev,
+         libsopt3.0t64 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Description: Development package for Sparse OPTimisation library

## sopt 4.2.0%2Bdfsg

=== cpp/tools_for_tests/CMakeLists.txt ===
add_library(tools_for_tests STATIC tiffwrappers.cc tiffwrappers.h)
target_link_libraries(tools_for_tests TIFF::TIFF)
target_link_libraries(tools_for_tests sopt)
target_include_directories(tools_for_tests PUBLIC
  "${CMAKE_CURRENT_SOURCE_DIR}/.."
  "${PROJECT_BINARY_DIR}/include/"
)
target_include_directories(tools_for_tests SYSTEM PUBLIC ${TIFF_INCLUDE_DIR})
if(EIGEN3_INCLUDE_DIR)
  target_include_directories(tools_for_tests SYSTEM PUBLIC ${EIGEN3_INCLUDE_DIR})
endif()


# Simple manual tester of read/write tiff
add_executable(copy_tiff copy_tiff.cc)
target_link_libraries(copy_tiff tools_for_tests sopt)

configure_file("directories.in.h" "${PROJECT_BINARY_DIR}/include/tools_for_tests/directories.h")
#file(MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/outputs")
#file(MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/outputs/sdmm")
